close all;
clear all;

[vertices, faceIndices] = importObj('../WebGL/models/BURKE_TestHead.obj');

fid = fopen('../WebGL/models/BURKE_TestHead_values.mhb');
values = fread(fid, 'float32');
fclose(fid);
fid = fopen('../WebGL/models/BURKE_TestHead_vectors.mhb');
vectors = fread(fid, 'float32');

%%
mhb = reshape(vectors, 9079, 50);

transformed = meshMHT(vertices, mhb);

reconstructed = meshINVMHT(transformed, mhb);

figure('name', 'Original mesh')
axis equal
trimesh(faceIndices, vertices(:,1), vertices(:,2), vertices(:,3))

figure('name', 'Reconstructed mesh')
axis equal
trimesh(faceIndices, reconstructed(:,1), reconstructed(:,2), reconstructed(:,3))

%%

diffOrigRec = vertices - reconstructed;
diffVertices = reconstructed + diffOrigRec;

figure('name', 'Reconstructed mesh + Difference')
axis equal
trimesh(faceIndices, diffVertices(:,1), diffVertices(:,2), diffVertices(:,3))

%% filter a little bit

filt = ones(size(mhb,2),1);
filt(25:40) = 0.1;

filtRec = meshINVMHT(transformed, mhb, filt);
filtRec = filtRec + diffOrigRec;

figure('name', 'Filtered Reconstructed mesh')
axis equal
trimesh(faceIndices, filtRec(:,1), filtRec(:,2), filtRec(:,3))
